﻿ using System.Collections.ObjectModel;
using System.ComponentModel;

namespace UsingXamOrgChart
{
    public class Department:INotifyPropertyChanged
    {
        public Department(string name)
        {
            this.Name = name;
            this.EmployeePositions = new ObservableCollection<EmployeePosition>();
        }

        public string Name { get; set; }
        ObservableCollection<EmployeePosition> employeepositions = new ObservableCollection<EmployeePosition>();


        public ObservableCollection<EmployeePosition> EmployeePositions
        
        {
            get { return employeepositions; }

            set {employeepositions = value;}
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

    }

    public class EmployeePosition
    {
        public EmployeePosition(string jobTitle)
        {
            this.JobTitle = jobTitle;
            this.Employees = new ObservableCollection<Employee>();
        }

        public string JobTitle { get; set; }
        public ObservableCollection<Employee> Employees { get; set; }
    }

    public class Employee
    {
        public Employee(string firstName, string lastName, string jobTitle)
        {
            this.FirstName = firstName;
            this.LastName = lastName;
            this.JobTitle = jobTitle;
        }

        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string JobTitle { get; set; }
    }

    public class DepartmentViewModel:INotifyPropertyChanged
    {
        ObservableCollection<Department> departments = new ObservableCollection<Department>();
        public ObservableCollection<Department> Departments
        {
            get { return departments; }

            set
            {
                departments = value;
                NotifyPropertyChanged("Departments");
            }
        }

        public DepartmentViewModel()
        {

            createDepartments();
         
        }

        public void createDepartments()
        {
            Employee employee1 = new Employee("Rob", "Walters", "Senior Tool Designer");
            Employee employee2 = new Employee("Ovidiu", "Cracium", "Senior Tool Designer");
            Employee employee3 = new Employee("Thierry", "D'Hers", "Tool Designer");
            Employee employee4 = new Employee("Janice", "Galvin", "Tool Designer");
            Employee employee5 = new Employee("Pete ", "rose", "Tool Designer");
            Employee employee6 = new Employee("John", "Bench", "Tool Designer");
            Employee employee7 = new Employee("Joe", "Morgan", "Tool Designer");
            Employee employee8 = new Employee("Tony", "Prez", "Tool Designer");
            Employee employee9 = new Employee("George", "Forster", "Tool Designer");
            Employee employee10 = new Employee("Cesar ", "Geronimo", "Tool Designer");
            //
            Employee employee15 = new Employee("Pete ", "rose", "Tool Designer");
            Employee employee16 = new Employee("John", "Bench", "Tool Designer");
            Employee employee17 = new Employee("Joe", "Morgan", "Tool Designer");
            Employee employee18 = new Employee("Tony", "Prez", "Tool Designer");
            Employee employee19 = new Employee("George", "Forster", "Tool Designer");
            Employee employee20 = new Employee("Cesar ", "Geronimo", "Tool Designer");



            EmployeePosition position1 = new EmployeePosition("Senior Tool Designer");
            position1.Employees.Add(employee1);
            position1.Employees.Add(employee2);
            position1.Employees.Add(employee15);
            position1.Employees.Add(employee16);
            position1.Employees.Add(employee18);
            position1.Employees.Add(employee17);
            position1.Employees.Add(employee19);
            position1.Employees.Add(employee20);

            EmployeePosition position2 = new EmployeePosition("Tool Designer");
            position2.Employees.Add(employee3);
            position2.Employees.Add(employee4);
            position2.Employees.Add(employee5);
            position2.Employees.Add(employee6);
            position2.Employees.Add(employee8);
            position2.Employees.Add(employee7);
            position2.Employees.Add(employee9);
            position2.Employees.Add(employee10);

            Department department1 = new Department("Tool Design");
            department1.EmployeePositions.Add(position1);
            department1.EmployeePositions.Add(position2);


          //  this.Departments = new ObservableCollection<Department>();
            this.Departments.Add(department1);
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

    }
}

